#ifndef COMMACROS_H
#define COMMACROS_H

#ifdef MACRO_ENABLE_dojedradek
static inline void
dojedradek (FILE * f)
{
  int c;
  do
    c = getc (f);
  while (c != '\n' && c != EOF);
}
#endif // MACRO_ENABLE_dojedradek

#ifdef MACRO_ENABLE_najdisloupec
/** Najde n-tý sloupec od současného umístění v proudu f (počítáno od nuly).
 *  
 *  Pomocná funkce pro dens_spline_initfun(). Sloupce jsou odděleny kladným
 *  počtem bílých znaků (isspace()).
 *  Používá se též v whamps_parf_maxwell_spline
 */
#include <ctype.h>
static inline int
najdisloupec (FILE * f, int n)	// n jde od nuly!
{
  int c;
  while (isspace (c = getc (f)))
    if (c == EOF)
      return EOF;
    else if (c == '\n')
      return '\n';
  for (int i = 0; i < n; i++)
    {
      while (!isspace (c = getc (f)))
	if (c == EOF)
	  return EOF;
	else if (c == '\n')
	  return '\n';
      while (isspace (c = getc (f)))
	if (c == EOF)
	  return EOF;
	else if (c == '\n')
	  return '\n';
    }

  if (c == EOF)
    return EOF;
  else if (c == '\n')
    return '\n';
  ungetc (c, f);
  return 0;
}
#endif // MACRO_ENABLE_najdisloupec

#endif // COMMACROS_H
