#ifndef IRIDENS_H
#define IRIDENS_H
#include "trace.h"
#include "fortrantypes.h"
extern const char *iri_data_path;	// Cesta k datovým souborům IRI
/* Vzhledem k tomu, že celé IRI stejně neumí pracovat vícevláknově, *
 * používám zde globální proměnné                                   */
extern integer iriwrap_iyyyy, iriwrap_mmdd;
extern real iriwrap_dhour;
extern integer iriwrap_jf[50];
#include "cold.h"
#define IRIDENS_MAX_S 8
densf_t iri;
struct iri_p
{
  int s;			// Počet „vypisovaných“ složek, <= 7
  int mapping[IRIDENS_MAX_S];	// Pořadí „výpisu“ složek
  int year;
  int day;
  double hour;
};

extern const char *const iri_ion_names[IRIDENS_MAX_S];
  /* = {"e", "O", "H", "He", "O2", "NO", "N", "cluster"} */

void iri_p_set_s (struct iri_p *p, int news);


/* ========== Staré struktury; nekanonické. ======== */
struct iri_dens1
{
  double e, o, h, he, o2, no, n, clus;
};

/* 
 * Je nutné spouštět z pracovního adresáře, kde jsou 
 * datové soubory s IGRF koeficienty!		
 */
struct iri_dens1 iri_getdens1 (rvec xyz);	// Vláknově nebezpečné?

//mat ortho_xz (rvec * b, rvec * k);

/* 
 * Pozor! Tohle ve skutečnosti pouze nastavuje globální proměnné v iricold.c. 
 * K samotnému výpočtu koeficientů pro daný čas dojde voláním iri_sub_ (které
 * si volá igrf_sub_) v iri_getdens();
 */
int iri_settime (integer year, integer day, real hour);	// Vláknově nebezpečné

// To hlavní -- susceptibilita
susc_t iri_cold;		// Vláknově nebezpečné?

//Wrapper pro igrf. Nutno nejdříve nastavit čas.
rvec igrf_b (rvec xyz, double *b_abs);

#endif /* IRIDENS_H */
