#ifndef MATVEC_H
#define MATVEC_H

/* 
 * Matice 3x3, vektory a některé operace s nimi; ideálně by zde měly
 * být inline definice
 */

#include <math.h>
#include <complex.h>


/* Vše v kartézských souřadnicích */

typedef struct
{
  double complex val[3];
} vec;

typedef struct
{
  double val[3];
} rvec;

// První index čísluje sloupec, druhý řádek (jinými slovy, "řádek"
// v paměti je sloupec matice):
typedef struct
{
  double complex val[3][3];
} mat;



double complex det (mat * m);
void mat_print (mat * m);
mat mat_mul_con (double complex a, mat * b);
mat mat_add (mat * a, mat * b);
mat mat_mul (mat * a, mat * b);
mat mat_tr (mat * a);		/* Transposice */
rvec rvec_mul_con (double con, rvec * x);
rvec rvec_add (rvec * x, rvec * y);	/* x + y */
rvec rvec_sub (rvec * x, rvec * y);	/* x - y */
complex double det (mat * m);
double rvec_norma (rvec * v);
double rvec_dist (rvec * x, rvec * y);
rvec rvec_normuj (rvec * x);

rvec rvec_vp (rvec * x, rvec * y);	// Vektorový součin

double rvec_in (rvec * a, rvec * b);	/* skalární součin */
mat kxkx (rvec k);		// kxkx(x) v = k x (k x v)

#include <stdio.h>
void mat_fprint (FILE * f, mat * m);
void mat_print (mat * m);

extern mat unit;		//Jednotková matice

mat ortho_xz (rvec * nz, rvec * xspan);

#endif /* MATVEC_H */
