#ifndef TRACE_H
#define TRACE_H

#include "matvec.h"
//#include <gsl/gsl_vector.h>
//#include <gsl/gsl_matrix.h>
//#include <gsl/gsl_matrix_complex_double.h>
#include "consts.h"


/* Momentálně pouze pro bezsrážkové plasma - reálné k */
// TODO napsat const, kam patří
typedef mat susc_t (rvec * r, rvec * k, double omega, void *susc_p);

/* Vrací magnetickou indukci v závislosti na poloze s volitelným parametrem */
typedef rvec magf_t (rvec * r, void *param);


/* TODO přesunout sem komentáře z trace.c */
double g_kmag (double c, void *param);

double g_abs_kmag (double c, void *param);

double interval (rvec r, rvec smer, double omega, susc_t susc, void *susc_p);

double groot1 (rvec r, rvec smer, double omega, susc_t susc, void *susc_p,
	       double *err);

double kmag (int vnitrni, rvec r, rvec smer, double omega,
	     susc_t susc, void *susc_p, double *err);

// Mod označuje, které řešení relace vzíti (menší |k| 1, větší -1)
void trace (rvec * r, rvec * smer, double omega,
	    int (*stop_podminky) (rvec poloha, void *param),
	    void *stop_podminky_param, double max_t, double krok, susc_t susc,
	    void *susc_param, int mod);

/* Dořešit výstup (tj. i návratovou hodnotu následujícího) */
//void trace (rvec * pocatek, rvec * smer,
//int (*stop_podminky) (rvec * poloha), susc_t susc);
//

// Následující deklarace byly původně v dummy.c; možná tu
// nakonec nebudou, neb jsou potřeba v dummy.c pro ladění (?)
struct g_par
{
  rvec r;
  rvec k;
  double complex omega;
  susc_t *susc;
  void *susc_p;
};

double gomega (double omega, void *param);

// Dispersní funkce. Za normálních okolností g_std, v odůvodněných případech lze změnit.
extern double complex (*g) (rvec r, rvec k, double complex omega, susc_t susc,
			    void *susc_p);

// Případně lze změnit parametry integračních kroků
// Viz referenční příručku ke GSL: ODE-> Adaptive Step-size Control
// Parametry numerické integrace
extern double D_HSTART;
extern double D_EPSABS;
extern double D_EPSREL;
// Velikost kroku derivace
extern double DKROK;
// Relativní přesnost hledání kořene dispersní relace vzhledem ke g(k = 0)
extern double R_ACC;
#endif /* TRACE_H */
