#include "fortrantypes.h"
#include "matvec.h"
#include "whamp.h"
#include <stdlib.h>
// common bloky z comin
extern struct
{
  real8 bvec[3], dbvdr[4][3], dbdr[4], dndr[6][4], drtr[6][4];
  complex16 ge[4][6];
  real8 vdrift[6], zign;
} plasma_;

extern struct
{
  complex16 xx[6];
  real8 pp[6], zz[6], aa[2][6] /*!?! */ , dd[6], ass[6], vd[6], dn[6], ta[6];
  complex16 xp[6];
  real8 cv, pm[3], zm[3], xoi, xc, pzl;
  integer jma;			/*? */
} xpz_;

// common blok z comcout
extern struct
{
  complex16 x;
  real8 p, z;
  complex16 efl[3], bfl[3], d, dx, dz, dp, e[4][6];
  real8 vg[2], sg[2], ri[2], ene;
} cout_;

int chi_ (complex16 (*xsi)[6] /*xsi[4][6] */ , integer * j, integer * ib,
	  integer * kol, integer * ierr);

int difu_ (integer * kol, integer * jmax, integer * ierr);

#define SET_S(nazev_p) void					\
nazev_p##_set_s (struct nazev_p *p, int news)			\
{								\
	if (news <= 0) {					\
		fprintf (stderr, "%s(): Počet složek má býti kladný!\n",__func__);\
		abort();					\
	}							\
	else if (news > WHAMP_MAX_S) {				\
		fprintf (stderr, "%s(): Počet složek pro WHAMP je nejvýše %d!\n",__func__, WHAMP_MAX_S); \
	}							\
	else if (news != p->s && p->s != 0)			\
		fprintf (stderr, "%s(): "			\
			"Varování: změna počtu složek (z %d na %d).\n", \
			__func__, p->s, news);			\
	p->s = news;						\
}

SET_S (whamps_p);
SET_S (whamps_parf_maxwell_spline_p);

#define SET_COMP_VALS(nazev_p, var, varslovy, typ) void			\
nazev_p##_set_##var (struct nazev_p *p, int s, typ *new_##var)		\
{									\
	if (s <= 0) {							\
		fprintf (stderr, "%s(): Počet složek má býti kladný!\n",__func__);\
		abort();						\
	}								\
	else if (s > WHAMP_MAX_S) {					\
		fprintf (stderr, "%s(): Počet složek pro WHAMP je nejvýše %d!\n",__func__, WHAMP_MAX_S); \
	}								\
	else if (s != p->s && p->s != 0)				\
		fprintf (stderr, "%s(): Varování: "			\
			"změna počtu složek (z %d na %d).\n", __func__, p->s, s); \
	p->s = s;							\
	/* Kontrola přenastavení zde není narozdíl od verze z cold.c */ \
	for (int i = 0; i < s; i++)					\
		p->var[i] = new_##var[i];				\
}

SET_COMP_VALS (whamps_p, intm, hmotnosti, long);
SET_COMP_VALS (whamps_p, q, n  boje, double);
SET_COMP_VALS (whamps_parf_maxwell_spline_p, cols_temp, sloupce  teplot,
	       long);
SET_COMP_VALS (whamps_parf_maxwell_spline_p, cols_dens, sloupce  hustot,
	       long);

mat
whamps (rvec * r, rvec * k, double omega, void *param)
{
  complex double omega_c = omega;
  complex double omega_c2 = omega_c * omega_c;
  struct whamps_p *p = param;
  p->parf (r, k, p, p->parf_p);
  rvec b = p->magf (r, p->magf_p);
  double b0 = rvec_norma (&b);
  mat tf = ortho_xz (&b, k);
  rvec ex, ey, ez;
  for (int i = 0; i < 3; i++)
    {
      ex.val[i] = tf.val[i][0];
      ey.val[i] = tf.val[i][1];
      ez.val[i] = tf.val[i][2];
    }
  double k_II = rvec_in (k, &ez);
  double k_I_ = rvec_in (k, &ex);
  for (int i = 0; i < p->s; i++)
    {
      double gyrof = p->gyrof_wb[i] * b0;
      xpz_.xx[i] = compl_c2f (omega_c / gyrof);
      double v_t = sqrt (2. * k_B * p->t[i] / p->m[i]);
      xpz_.pp[i] = k_I_ * v_t / gyrof;
      xpz_.zz[i] = k_II * v_t / gyrof;
      xpz_.vd[i] = p->v_d[i] / v_t;
      xpz_.ta[i] = p->t[i] * K2KEV;	// xpz_.ta[i] je v elektronvoltech, p->t[i] v Kelvinech
      xpz_.xp[i] =
	compl_c2f (p->plasmaf_wn2[i] * p->n[i] /*_U_*/  / omega_c2);
    }
  {
    double v_t0 = sqrt (2. * k_B * p->t[0] / p->m[0]);
    xpz_.cv = C / v_t0;
  }
  double plasmaf2_tot = 0;
  for (int i = 0; i < p->s; i++)
    plasmaf2_tot += p->plasmaf_wn2[i] * p->n[i] /*_U_*/ ;
  mat susc1 = { {{-plasmaf2_tot / omega_c2, 0, 0}, {0, -plasmaf2_tot / omega_c2, 0}, {0, 0, -plasmaf2_tot / omega_c2}} };	// Neztransformovaná do správných souřadnic
  complex16 xsi[4][6];
  integer ib;
  integer jmax = p->s;
  integer kol = 0;		// ?? Možná to budeme potřebovat, ale ne tady.
  integer ierr;
  for (int i = 0; i < p->s; i++)
    {
      for (int ib = 1; ib <= 2; ib++)
	{
	  // Viz Report, (II-11)
	  double fac =
	    (ib ==
	     1) ? (xpz_.aa[0][i] -
		   xpz_.dd[i] * xpz_.aa[1][i]) : (xpz_.aa[0][i] *
						  (xpz_.dd[i] - 1.));
	  if (0. == fac)
	    continue;
	  chi_ (xsi, &ib, &kol, &jmax, &ierr);
	  if (ierr == 1)
	    {
	      fprintf (stderr, "%s: Příliš silný útlum. Končím.\n",
		       __func__);
	      abort ();
	    }
	  // Viz Report, (II-16)
	  susc1.val[0][0] += fac * compl_f2c (xsi[0][0]);
	  susc1.val[1][0] += fac * compl_f2c (xsi[0][1]);
	  susc1.val[0][1] -= fac * compl_f2c (xsi[0][1]);
	  susc1.val[2][0] += fac * compl_f2c (xsi[0][2]);
	  susc1.val[0][2] += fac * compl_f2c (xsi[0][2]);
	  susc1.val[1][1] += fac * compl_f2c (xsi[0][3]);
	  susc1.val[2][1] += fac * compl_f2c (xsi[0][4]);
	  susc1.val[1][2] -= fac * compl_f2c (xsi[0][4]);
	  susc1.val[2][2] += fac * compl_f2c (xsi[0][5]);
	}
    }
  // Transformace do původních souřadnic.
  susc1 = mat_mul (&susc1, &tf);
  tf = mat_tr (&tf);
  susc1 = mat_mul (&tf, &susc1);
  return susc1;
}

// Volat po nastavení s, intm, q.
int
whamps_init (struct whamps_p *p)
{
  for (int i = 0; i < p->s; i++)
    {
      p->m[i] = p->intm[i] ? (m_p * p->intm[i]) : m_e;
      p->gyrof_wb[i] = p->q[i] / p->m[i];
      p->plasmaf_wn2[i] = SQ (p->q[i]) / (epsilon_0 * p->m[i]);
      p->v_d[i] = 0;
    }
  return 0;
}

#include <gsl/gsl_errno.h>
int
whamps_parf_maxwell_spline (rvec * rv, rvec * k,
			    struct whamps_p *whamps_param, void *self_param)
{
  struct whamps_parf_maxwell_spline_p *p = self_param;
  double r = rvec_norma (rv);
  int ec;
  for (int i = 0; i < p->s; i++)
    {
      if (ec =
	  gsl_interp_eval_e (p->funcs_temp[i], p->heights, p->temps[i], r,
			     p->accs_temp[i], whamps_param->t + i))
	{
	  fprintf (stderr, "%s: %d %s\n", __func__, ec, gsl_strerror (ec));
	  abort ();
	}
      if (ec =
	  gsl_interp_eval_e (p->funcs_dens[i], p->heights, p->denss[i], r,
			     p->accs_dens[i], whamps_param->n + i))
	{
	  fprintf (stderr, "%s: %d %s\n", __func__, ec, gsl_strerror (ec));
	  abort ();
	}
    }
  return 0;
}

#define REWIND(fr) if (fseek(fr, 0L, SEEK_SET)) { \
	perror(__func__); \
	abort(); \
}

#define MACRO_ENABLE_dojedradek
#define MACRO_ENABLE_najdisloupec
#include "commacros.h"
int
whamps_parf_maxwell_spline_cmp (const void *a, const void *b)	// pro qsort()
{
  if ((*((double (*)[1 + 2 * WHAMP_MAX_S]) a))[0] <
      (*((double (*)[1 + 2 * WHAMP_MAX_S]) b))[0])
    return -1;
  if ((*((double (*)[1 + 2 * WHAMP_MAX_S]) a))[0] ==
      (*((double (*)[1 + 2 * WHAMP_MAX_S]) b))[0])
    return 0;
  return 1;
}

int
whamps_parf_maxwell_spline_initfun (struct whamps_parf_maxwell_spline_p *p,
				    int s, const char filename[], int heicol,
				    int *denscols, int *tempcols)
{
  p->s = s;
  FILE *fr;
  if (!(fr = fopen (filename, "r")))
    {
      perror (__func__);
      abort ();
    }
/* 
 * Velmi škaredé, ale funkční řešení. Soubor se čte až čtrnáctkrát, pokaždé
 * zvlášť. Soubor musí být pochopitelně „a seekable stream“.
 */
// Nejdřív zjistíme počet řádek, ať nemusíme malloc volat mockrát.
  int lines = 1;
  int c;
  while ((c = getc (fr)) != EOF)
    if (c == '\n')
      lines++;
  p->heights = malloc (lines * sizeof (double));
  for (int i = 0; i < s; i++)
    {
      p->temps[i] = malloc (lines * sizeof (double));
      p->denss[i] = malloc (lines * sizeof (double));
    }
  // Výšky
  REWIND (fr);
  int i = 0;
  while (EOF != (c = getc (fr)))
    if (ungetc (c, fr), c == '#')
      dojedradek (fr);
    else if (najdisloupec (fr, heicol - 1))
      break;
    else if (1 != fscanf (fr, "%lf", p->heights + i))
      break;
    else
      {
	++i;
	dojedradek (fr);
      }
  lines = i;			// Reálný počet řádků s hodnotami je menší
  // Hustoty
  for (int densno = 0; densno < s; densno++)
    {
      REWIND (fr);
      i = 0;
      while (EOF != (c = getc (fr)))
	if (ungetc (c, fr), c == '#')
	  dojedradek (fr);
	else if (najdisloupec (fr, denscols[densno] - 1))
	  break;
	else if (1 != fscanf (fr, "%lf", p->denss[densno] + i))
	  break;
	else
	  {
	    ++i;
	    dojedradek (fr);
	  }
      lines = (lines > i) ? i : lines;
    }
  // Teploty
  for (int tempno = 0; tempno < s; tempno++)
    {
      REWIND (fr);
      i = 0;
      while (EOF != (c = getc (fr)))
	if (ungetc (c, fr), c == '#')
	  dojedradek (fr);
	else if (najdisloupec (fr, tempcols[tempno] - 1))
	  break;
	else if (1 != fscanf (fr, "%lf", p->temps[tempno] + i))
	  break;
	else
	  {
	    ++i;
	    dojedradek (fr);
	  }
      lines = (lines > i) ? i : lines;
    }
  for (int i = 1; i < lines; i++)
    if (p->heights[i] <= p->heights[i - 1])
      {
	/* gsl_interp_alloc() vyžaduje ostře rostoucí x */
	fprintf (stderr, "%s: sloupec r není ostře rostoucí; seřazuji.\n",
		 __func__);
	double tmp[lines][1 + 2 * WHAMP_MAX_S];
	for (int j = 0; j < lines; j++)
	  {
	    tmp[j][0] = p->heights[j];
	    for (int ii = 0; ii < s; ii++)
	      {
		tmp[j][1 + ii] = p->denss[ii][j];
		tmp[j][1 + WHAMP_MAX_S + ii] = p->temps[ii][j];
	      }
	  }
	qsort (tmp, lines, sizeof (double[1 + 2 * WHAMP_MAX_S]),
	       whamps_parf_maxwell_spline_cmp);
	for (int j = 0; j < lines; j++)
	  {
	    p->heights[j] = tmp[j][0];
	    for (int ii = 0; ii < s; ii++)
	      {
		p->denss[ii][j] = tmp[j][1 + ii];
		p->temps[ii][j] = tmp[j][1 + WHAMP_MAX_S + ii];
	      }
	  }
	break;
      }
  p->size = lines;
  for (int i = 0; i < s; i++)
    {
      p->funcs_temp[i] = gsl_interp_alloc (gsl_interp_cspline, lines);
      p->funcs_dens[i] = gsl_interp_alloc (gsl_interp_cspline, lines);
      gsl_interp_init (p->funcs_temp[i], p->heights, p->temps[i], lines);
      gsl_interp_init (p->funcs_dens[i], p->heights, p->denss[i], lines);
      p->accs_temp[i] = gsl_interp_accel_alloc ();
      p->accs_dens[i] = gsl_interp_accel_alloc ();
    }
  // Isotropní Maxwell => tyto parametry zůstávají neměnné:
  for (int i = 1; i < s; i++)
    {
      xpz_.dd[i] = 1;
      xpz_.aa[0][i] = 1;
      xpz_.aa[1][i] = 4;	// Tato hodnota by neměla hrát žádnou roli.
      xpz_.vd[i] = 0;		// Žádný drift

    }
  return 0;
}

void
whamps_parf_maxwell_spline_clean (struct whamps_parf_maxwell_spline_p *p)
{
  for (int i = 0; i < p->s; i++)
    {
      gsl_interp_accel_free (p->accs_temp[i]);
      gsl_interp_accel_free (p->accs_dens[i]);
      gsl_interp_free (p->funcs_temp[i]);
      gsl_interp_free (p->funcs_dens[i]);
      free (p->temps[i]);
      free (p->denss[i]);
    }
  free (p->heights);
}


double complex
difu_whamp (rvec r, rvec k, double complex omega, susc_t susc /*nic */ ,
	    void *par)
{
  struct whamps_p *p = par;
  complex double omega_2 = omega * omega;
  p->parf (&r, &k, p, p->parf_p);
  rvec b = p->magf (&r, p->magf_p);
  double b0 = rvec_norma (&b);
  mat tf = ortho_xz (&b, &k);
  rvec ex, ey, ez;
  for (int i = 0; i < 3; i++)
    {
      ex.val[i] = tf.val[i][0];
      ey.val[i] = tf.val[i][1];
      ez.val[i] = tf.val[i][2];
    }
  double k_II = rvec_in (&k, &ez);
  double k_I_ = rvec_in (&k, &ex);
  for (int i = 0; i < p->s; i++)
    {
      double gyrof = p->gyrof_wb[i] * b0;
      xpz_.xx[i] = compl_c2f (omega / gyrof);
      double v_t = sqrt (2. * k_B * p->t[i] / p->m[i]);
      xpz_.pp[i] = k_I_ * v_t / gyrof;
      xpz_.zz[i] = k_II * v_t / gyrof;
      xpz_.vd[i] = p->v_d[i] / v_t;
      xpz_.ta[i] = p->t[i] * K2KEV;
      xpz_.xp[i] = compl_c2f (p->plasmaf_wn2[i] * p->n[i] / omega_2);
    }
  {
    double v_t0 = sqrt (2. * k_B * p->t[0] / p->m[0]);
    xpz_.cv = C / v_t0;
  }
  integer jmax = p->s;
  integer kol = 4;
  integer ierr = 0;
  difu_ (&kol, &jmax, &ierr);
  double complex difu = compl_f2c (cout_.d);
  return difu;
}
